#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "konstant.h"
#include "pol_dat.h"
#include "tpole.h"
#include "tdatabaz.h"
#include "tautor.h"
#include "tdatauto.h"

#pragma option -Jgx

//vrati autora s danym id
TAutor* TDatabazeAutor::dejPolozku(long int ident)
{
  for(int q=0;q<pocet;q++)
  {
    if((polozky[q]->dejId())==ident)
      return polozky[q];
  }
  return NULL;
}


//vrati id, ktere nema zadny autor v databazi
long int TDatabazeAutor::dejVolneId(){
  volne_id++;
  return volne_id;
}

//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeAutor::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni++;
    return polozky[aktualni];
  }
  else
    return NULL;
}


//vrati ukazatel na polozku databaze pred aktualni pozici
void* TDatabazeAutor::dejPredchozi(){
  if(aktualni>0)
  {
    aktualni--;
    return polozky[aktualni];
  }
  else
    return NULL;
}


//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeAutor::ubratPolozku(TAutor *smazat){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==smazat)
    {
      polozky.ubrat(i);
      pocet--;
      break;
    }
  }
}

//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeAutor::zmenitPolozku(TAutor *stara, TAutor *nova){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      strcpy(polozky[i]->dejJmeno(),nova->dejJmeno());
      polozky[i]->zmenId(nova->dejId());
      break;
    }
  }
}


//provede ulozeni vsech polozek do souboru
void TDatabazeAutor::ulozitDoSouboru(){
  file =fopen(soubor,"w");
  if(file==NULL)
    cerr<<"Soubor nelze otevrit.\n";
  char *jm;
  long int i;
  for(int f=0; f<pocet; f++){
    i=polozky[f]->dejId();
    jm=polozky[f]->dejJmeno();
    fprintf(file,"%ld %s\n",i,jm);
  }
  fclose(file);
}

//nacte ze souboru polozky
void TDatabazeAutor::nacistSoubor(){
  TAutor *uk;
  char *jm;
  long int i;
  int j;
  char znak;

  if((file=fopen(soubor,"r"))==NULL)
    cerr<<"Soubor nelze otevrit";
  while(!feof(file))
  {
    if((jm=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    if(fscanf(file,"%ld",&i)!=1) break;
    j=0;
    do{
      znak=fgetc(file);
      if(j!=0 || znak!=' ')
      {
	jm[j]=znak;
	j++;
      }
    }while(znak!='\0' && znak!='\n' && !feof(file));
    jm[j-1]='\0';
    if((uk=new TAutor(jm,i))==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    pridatPolozku(uk);         //ulozi ukazatel na novou polozku do databaze
  }
  for(j=0;j<pocet;j++)
    if(polozky[j]->dejId()>=volne_id)
      volne_id=polozky[j]->dejId()+1;
}

//konstruktor
TDatabazeAutor::TDatabazeAutor(const char *soub){
  volne_id=0L;
  soubor=soub;
  aktualni=-1;
  pocet=0;
}


//prida do databaze novou polozku
void TDatabazeAutor::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;
  polozky.uloz((TAutor *)jina,pocet-1);
}


