#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "tctenar.h"
#include "tdatabaz.h"
#include "tdatcten.h"

#pragma option -Jgx

//vrati ctenare s danym id
TCtenar* TDatabazeCtenar::dejPolozku(long int ident)
{
  for(int q=0;q<pocet;q++)
  {
    if((polozky[q]->dejId())==ident)
      return polozky[q];
  }
  return NULL;
}


//vrati id, ktere nema zadny ctenar v databazi
long int TDatabazeCtenar::dejVolneId(){
  volne_id++;
  return volne_id;
}

//vrati ukazatel na polozku databaze na aktualni pozici//vrati ukazatel na polozku databaze pred aktualni pozici
void* TDatabazeCtenar::dejPredchozi(){
  if(aktualni>0)
  {
    aktualni--;
    return polozky[aktualni];
  }
  else
    return NULL;
}

//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeCtenar::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni+=1;
    return polozky[aktualni];
  }
  else
    return NULL;
}

//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeCtenar::ubratPolozku(TCtenar *smazat){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==smazat)
    {
      polozky.ubrat(i);
      pocet--;
      break;
    }
  }
}

//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeCtenar::zmenitPolozku(TCtenar *stara, TCtenar *nova){
  char *ret;
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      strcpy(polozky[i]->dejJmeno(),nova->dejJmeno());
      if(polozky[i]->dejAdresa()!=NULL)
	strcpy(polozky[i]->dejAdresa(),nova->dejAdresa());
      else{
	if((ret=new char[RETEZEC])==NULL){
	  cerr<<"Malo pameti pro beh programu.";
	  exit(0);
	}
	else{
	  strcpy(ret,nova->dejAdresa());
	  polozky[i]->zmenAdresa(ret);
	}
      }
      if(polozky[i]->dejRC()!=NULL){
	strcpy(polozky[i]->dejRC(),nova->dejRC());
      }
      else{
	if((ret=new char[RC_ZNAKU])==NULL){
	  cerr<<"Malo pameti pro beh programu.";
	  exit(0);
	}
	else{
	  strcpy(ret,nova->dejRC());
	  polozky[i]->zmenRC(ret);
	}
      }
      polozky[i]->zmenId(nova->dejId());
      break;
    }
  }
}



//provede ulozeni vsech polozek do souboru
void TDatabazeCtenar::ulozitDoSouboru(){
  file =fopen(soubor,"w");
  if(file==NULL) cerr<<"Soubor nelze otevrit.\n";
  else{
   char *jm,*adr,*rc;
   long int i;
   for(int f=0; f<pocet; f++){
    i=polozky[f]->dejId();
    jm=polozky[f]->dejJmeno();
    adr=polozky[f]->dejAdresa();
    rc=polozky[f]->dejRC();
    fprintf(file,"%ld %s%c",i,jm,'\0');
    if(adr==NULL)
    {
      if((adr=new char[RETEZEC])==NULL){
	cerr<<"Malo pameti pro beh programu.";
	exit(0);
      }
      adr[0]='\0';
      fprintf(file,"%s%c",adr,'\0');
      delete adr;
    }
    else
      fprintf(file,"%s%c",adr,'\0');
    if(rc==NULL)
    {
      if((rc=new char[RETEZEC])==NULL){
	cerr<<"Malo pameti pro beh programu.";
	exit(0);
      }
      rc[0]='\0';
      fprintf(file,"%s%c\n",rc,'\0');
      delete rc;
    }
    else
      fprintf(file,"%s%c\n",rc,'\0');
   }
   fclose(file);
  }
}


//nacte ze souboru polozky
void TDatabazeCtenar::nacistSoubor(){
  TCtenar *uk;
  char *jm,*adr,*rc;
  long int i;
  int j;
  char znak;

  file=fopen(soubor,"r");
  if(file==NULL) cerr<<"Soubor nelze otevrit.\n";
  else{
   while(!feof(file))
   {
    if((jm=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    if((adr=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    if((rc=new char[RC_ZNAKU])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }

    if(fscanf(file,"%ld",&i)!=1) break;
    j=0;
    do{
      znak=fgetc(file);
      if(znak!=' '||j!=0)
      {
	jm[j]=znak;
	j++;
      }
    }while(znak!='\0' && znak!='\n' && !feof(file));
    jm[j]='\0';

    j=0;
    do{
      znak=fgetc(file);
      adr[j]=znak;
      j++;
    }while(znak!='\0' && znak!='\n' && !feof(file));
    adr[j]='\0';
    if(adr[0]=='\0')
    {
      delete adr;
      adr=NULL;
    }

    j=0;
    do{
      znak=fgetc(file);
      rc[j]=znak;
      j++;
    }while(znak!='\0' && znak!='\n' && !feof(file));
    rc[j]='\0';
    if(rc[0]=='\0')
    {
      delete rc;
      rc=NULL;
    }
    if((uk=new TCtenar(i,jm,adr,rc))==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    pridatPolozku(uk);
   }
   for(j=0;j<pocet;j++)
     if(polozky[j]->dejId()>=volne_id)
       volne_id=polozky[j]->dejId()+1;
  }
}

//konstruktor
TDatabazeCtenar::TDatabazeCtenar(const char *soub){
  soubor=soub;
  aktualni=-1;
  pocet=0;
  volne_id=0L;
}

//prida do databaze novou polozku
void TDatabazeCtenar::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;
  polozky.uloz((TCtenar *)jina,pocet-1);
}

