#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "tdatabaz.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tdattitu.h"
#include "tdatknih.h"


#pragma option -Jgx

//existuje-li kniha s danym isbn, vrati ukazatel na ni
TKniha* TDatabazeKniha::existuje(char *is){
  for(int q=0;q<pocet;q++)
  {
    if(strcmp(is,polozky[q]->dejIsbn())==0)
      return polozky[q];
  }
  return NULL;
}

//vrati knihu s danym id
TKniha* TDatabazeKniha::dejPolozku(long int ident)
{
  for(int q=0;q<pocet;q++)
  {
    if((polozky[q]->dejId())==ident)
      return polozky[q];
  }
  return NULL;
}

//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeKniha::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni+=1;
    return polozky[aktualni];
  }
  else
    return NULL;
}

//vrati ukazatel na polozku databaze na aktualni pozici//vrati ukazatel na polozku databaze pred aktualni pozici
void* TDatabazeKniha::dejPredchozi(){
  if(aktualni>0)
  {
    aktualni--;
    return polozky[aktualni];
  }
  else
    return NULL;
}

//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeKniha::ubratPolozku(TKniha *smazat){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==smazat)
    {
      polozky.ubrat(i);
      pocet--;
      break;
    }
  }
}

//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeKniha::zmenitPolozku(TKniha *stara, TKniha *nova){
  char *ret;
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      strcpy(polozky[i]->dejNazev(),nova->dejNazev());
      strcpy(polozky[i]->dejIsbn(),nova->dejIsbn());
      if(polozky[i]->dejNakladatel()!=NULL)
	strcpy(polozky[i]->dejNakladatel(),nova->dejNakladatel());
      else{
	if((ret=new char[RETEZEC])==NULL){
	  cerr<<"Malo pameti pro beh programu.";
	  exit(0);
	}
	else{
	  strcpy(ret,nova->dejNakladatel());
	  polozky[i]->zmenNakladatel(ret);
	}
      }
      polozky[i]->zmenPocetStran(stara->dejPocetStran());
      polozky[i]->zmenRok(stara->dejRok());
      break;
    }
  }
}

//provede ulozeni vsech polozek do souboru
void TDatabazeKniha::ulozitDoSouboru(){
  file =fopen(soubor,"w");
  if(file==NULL) cout<<"Soubor nelze otevrit.\n";
  char *naz,*nak,*is;
  long int i;
  int r,p;
  for(int f=0; f<pocet; f++){
    i=polozky[f]->dejId();
    is=polozky[f]->dejIsbn();
    naz=polozky[f]->dejNazev();
    p=polozky[f]->dejPocetStran();
    nak=polozky[f]->dejNakladatel();
    r=polozky[f]->dejRok();
    if(nak==NULL)
    {
      nak=new char[RETEZEC];
      nak[0]='\0';
    }
    fprintf(file,"%ld %s%c%s%c %d %d %s%c\n",i,is,'\0',naz,'\0',p,r,nak,'\0');
  }
  fclose(file);
}


void TDatabazeKniha::nacistSoubor(){
  TKniha *uk;
  char *naz,*nak,*is;
  long int i;
  int r,p,j;
  char znak;

  file=fopen(soubor,"r");
  if(file==NULL) cout<<"Soubor nelze otevrit.\n";
  while(!feof(file))
  {
    if((is=new char[ISBN_ZNAKU])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    if((naz=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    if((nak=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }

    if(fscanf(file,"%ld",&i)!=1) break;
    j=0;
    do{
      znak=fgetc(file);
      if(j!=0 || znak!=' ')
      {
	is[j]=znak;
	j++;
      }
    }while(znak!='\0' && znak!='\n');
    j=0;
    do{
      znak=fgetc(file);
      if(j!=0 || znak!=' ')
      {
	naz[j]=znak;
	j++;
      }
    }while(znak!='\0' && znak!='\n');
    fscanf(file,"%d %d",&p,&r);
    j=0;
    do{
      znak=fgetc(file);
      if(j!=0 || znak!=' ')
      {
	nak[j]=znak;
	j++;
      }
    }while(znak!='\0' && znak!='\n');
    if(nak[0]=='\0'){
      delete nak;
      nak=NULL;
    }
    if((uk=new TKniha(i,is,naz,p,nak,r))==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    pridatPolozku(uk);
  }
  for(j=0;j<pocet;j++)
    if(polozky[j]->dejId()>=volne_id)
      volne_id=polozky[j]->dejId()+1;
}


//konstruktor
TDatabazeKniha::TDatabazeKniha(const char *soub){
  soubor=soub;
  aktualni=-1;
  pocet=0;
}


//prida do databaze novou polozku
void TDatabazeKniha::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;

  polozky.uloz((TKniha *)jina,pocet-1);
}




