#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"


#pragma option -Jgx

//vrati pole ukazatelu na kopie daneho titulu
TKopie** TDatabazeKopie::dejPolozky(TKniha *kniha,int *poc)
{
  TKopie **vysledek;
  TKopie **vysledek2;
  int kolik=0;
  vysledek=NULL;
  for(int q=0;q<pocet;q++)
  {
    if(kniha==polozky[q]->dejTitul())
    {
      kolik++;
      if((vysledek2=new TKopie*[kolik])==NULL){
	cerr<<"Malo pameti"<<endl;
	exit(0);
      }
      for(int k=0;k<kolik-1;k++)
	vysledek2[k]=vysledek[k];
      delete vysledek;
      vysledek=vysledek2;
      vysledek[k]=polozky[q];
    }
  }
  *poc=kolik;
  return vysledek;
}

//vrati ukazatel na kopii s danym prirustkovym cislem
TKopie* TDatabazeKopie::dejPolozku(long int ident)
{
  for(int q=0;q<pocet;q++)
  {
    if((polozky[q]->dejPrirC())==ident)
      return polozky[q];
  }
  return NULL;
}

//definuje ukazatele na tituly
void TDatabazeKopie::utvorVazby(TDatabazeKniha *dkn){
  TKniha *ptrkn;
  for(int q=0;q<pocet;q++)
  {
    if( (ptrkn = (dkn->dejPolozku(polozky[q]->dejId()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenTitul(ptrkn);
  }
}


//vrati prirustkove cislo, ktere nema zadna kopie v databazi
long int TDatabazeKopie::dejVolnePrir(){
  volne_prir++;
  return volne_prir;
}


//vrati ukazatel na polozku databaze na aktualni pozici//vrati ukazatel na polozku databaze pred aktualni pozici
void* TDatabazeKopie::dejPredchozi(){
  if(aktualni>0)
  {
    aktualni--;
    return polozky[aktualni];
  }
  else
    return NULL;
}



//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeKopie::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni+=1;
    return polozky[aktualni];
  }
  else
    return NULL;
}


//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeKopie::ubratPolozku(TKopie *smazat){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==smazat)
    {
      polozky.ubrat(i);
      pocet--;
      break;
    }
  }
}


//smaze kopie daneho titulu
/*void TDatabazeKopie::ubratPolozkyTit(TKniha *ti){
  for(int l=0;l<pocet;l++)
  {
    if(polozky[l]->dejTitul()==ti)
    {
      polozky.ubrat(l);
      pocet--;
    }
  }
} */


//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeKopie::zmenitPolozku(TKopie *stara, TKopie *nova){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      polozky.uloz(nova,i);
      delete stara;
      break;
    }
  }
}



//provede ulozeni vsech polozek do souboru
void TDatabazeKopie::ulozitDoSouboru(){
  long int i,prir;

  file =fopen(soubor,"w");
  if(file==NULL) cout<<"Soubor nelze otevrit.\n";
  else{
    for(int f=0; f<pocet; f++){
      i=polozky[f]->dejId();
      prir=polozky[f]->dejPrirC();
      fprintf(file,"%ld %ld\n",i,prir);
    }
    fclose(file);
  }
}


//nacte ze souboru polozky
void TDatabazeKopie::nacistSoubor(){
  TKopie *uk;
  long int i,p;

  file=fopen(soubor,"r");
  if(file==NULL) cerr<<"Soubor nelze otevrit.\n";
  else{
    while(!feof(file))
    {
      if(fscanf(file,"%ld %ld",&i,&p)!=2) break;
      if((uk=new TKopie(p,i))==NULL){
	cerr<<"Malo pameti"<<endl;
	exit(0);
      }
      pridatPolozku(uk);
    }
    for(int j=0;j<pocet;j++)
      if(polozky[j]->dejPrirC()>=volne_prir)
	volne_prir=polozky[j]->dejPrirC()+1;
  }
}


//konstruktor
TDatabazeKopie::TDatabazeKopie(const char *soub){
  volne_prir=1L;
  soubor=soub;
  aktualni=-1;
  pocet=0;
}


//prida do databaze novou polozku
void TDatabazeKopie::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;

  polozky.uloz((TKopie *)jina,pocet-1);
}



