#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tautor.h"
#include "tkniha.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatauto.h"
#include "tdatnaps.h"


#pragma option -Jgx
//vrati pole ukazatelu na polozky podle titulu
TNapsal** TDatabazeNapsal::dejPolozky(TKniha *kniha,int *poc)
{
  TNapsal **vysledek;
  TNapsal **vysledek2;
  int kolik=0;
  vysledek=NULL;
  for(int q=0;q<pocet;q++)
  {
    if(kniha==polozky[q]->dejTitul())
    {
      kolik++;
      vysledek2=new TNapsal*[kolik];
      for(int k=0;k<kolik-1;k++)
	vysledek2[k]=vysledek[k];
      delete vysledek;
      vysledek=vysledek2;
      vysledek[k]=polozky[q];
    }
  }
  *poc=kolik;
  return vysledek;
}


//vrati pole ukazatelu na polozky podle autoru
TNapsal** TDatabazeNapsal::dejPolozky(TAutor *autor,int *poc)
{
  TNapsal **vysledek;
  TNapsal **vysledek2;
  int kolik=0;
  vysledek=NULL;
  for(int q=0;q<pocet;q++)
  {
    if(autor==polozky[q]->dejAutor())
    {
      kolik++;
      vysledek2=new TNapsal*[kolik];
      for(int k=0;k<kolik-1;k++)
	vysledek2[k]=vysledek[k];
      delete vysledek;
      vysledek=vysledek2;
      vysledek[k]=polozky[q];
    }
  }
  *poc=kolik;
  return vysledek;
}

//definuje ukazatele na tituly
void TDatabazeNapsal::utvorVazbyTit(TDatabazeKniha *kn){
  TKniha *ptr;
  for(int q=0;q<pocet;q++)
  {
    if( (ptr = (kn->dejPolozku(polozky[q]->dejIdt()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenTitul(ptr);
  }
}

//definuje ukazatele na autory
void TDatabazeNapsal::utvorVazbyAut(TDatabazeAutor *au){
  TAutor *ptr;
  for(int q=0;q<pocet;q++)
  {
    if( (ptr = (au->dejPolozku(polozky[q]->dejIda()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenAutor(ptr);
  }
}


//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeNapsal::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni+=1;
    return polozky[aktualni];
  }
  else
    return NULL;
}

//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeNapsal::ubratPolozku(TNapsal *smazat){
  for(int n=0;n<pocet;n++)
  {
    if(polozky[n]==smazat)
    {
      polozky.ubrat(n);
      pocet--;
      break;
    }
  }
}

//zrusi vazby na dany titul
/*void TDatabazeNapsal::ubratPolozkyKnih(TKniha *stkniha){
  for(int m=0;m<pocet;m++)
  {
    if(polozky[m]->dejTitul()==stkniha)
    {
      polozky.ubrat(m);
      pocet--;
    }
  }
} */

//zrusi vazby na daneho autora
/*void TDatabazeNapsal::ubratPolozkyAut(TAutor *stautor){
  for(int r=0;r<pocet;r++)
  {
    if(polozky[r]->dejAutor()==stautor)
    {
      polozky.ubrat(r);
      pocet--;
    }
  }
} */


//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeNapsal::zmenitPolozku(TNapsal *stara, TNapsal *nova){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      polozky.uloz(nova,i);
      delete stara;
      break;
    }
  }
}



//provede ulozeni vsech polozek do souboru
void TDatabazeNapsal::ulozitDoSouboru(){
  long int ia,it;

  file =fopen(soubor,"w");
  if(file==NULL) cerr<<"Soubor nelze otevrit.\n";
  else{
    for(int f=0; f<pocet; f++){
      ia=polozky[f]->dejIda();
      it=polozky[f]->dejIdt();
      fprintf(file,"%ld %ld\n",ia,it);
    }
    fclose(file);
  }
}


//nacte ze souboru polozky
void TDatabazeNapsal::nacistSoubor(){
  TNapsal *uk;
  long int ia,it;

  file=fopen(soubor,"r");
  if(file==NULL) cerr<<"Soubor nelze otevrit.\n";
  else{
    while(!feof(file))
    {
      if(fscanf(file,"%ld %ld",&ia,&it)!=2) break;
      if((uk=new TNapsal(ia,it))==NULL){
	cerr<<"Malo pameti"<<endl;
	exit(0);
      }
      pridatPolozku(uk);
    }
  }
}

//konstruktor
TDatabazeNapsal::TDatabazeNapsal(const char *soub){
  soubor=soub;
  aktualni=-1;
  pocet=0;
}


//prida do databaze novou polozku
void TDatabazeNapsal::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;
  polozky.uloz((TNapsal *)jina,pocet-1);
}

