#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tctenar.h"
#include "trezerva.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatcten.h"
#include "tdatreze.h"

#pragma option -Jgx

//vrati pole ukazatelu na vypujcky daneho ctenare
TRezervace** TDatabazeRezervace::dejPolozky(TCtenar *ctenar,int *poc)
{
  TRezervace **vysledek;
  TRezervace **vysledek2;
  int kolik=0;
  vysledek=NULL;
  for(int q=0;q<pocet;q++)
  {
    if(ctenar==polozky[q]->dejCtenar())
    {
      kolik++;
      vysledek2=new TRezervace*[kolik];
      for(int k=0;k<kolik-1;k++)
	vysledek2[k]=vysledek[k];
      delete vysledek;
      vysledek=vysledek2;
      vysledek[k]=polozky[q];
    }
  }
  *poc=kolik;
  return vysledek;
}

//definuje ukazatele na titul
void TDatabazeRezervace::utvorVazbyTit(TDatabazeKniha *kn){
  TKniha *ptr;
  for(int q=0;q<pocet;q++)
  {
    if( (ptr = (kn->dejPolozku(polozky[q]->dejIdt()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenTitul(ptr);
  }
}

//definuje ukazatele na ctenare
void TDatabazeRezervace::utvorVazbyCten(TDatabazeCtenar *ct){
  TCtenar *ptr;
  for(int q=0;q<pocet;q++)
  {
    if( (ptr = (ct->dejPolozku(polozky[q]->dejIdc()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenCtenar(ptr);
  }
}


//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeRezervace::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni+=1;
    return polozky[aktualni];
  }
  else
    return NULL;
}


//vrati ukazatel na polozku databaze na aktualni pozici//vrati ukazatel na polozku databaze pred aktualni pozici
void* TDatabazeRezervace::dejPredchozi(){
  if(aktualni>0)
  {
    aktualni--;
    return polozky[aktualni];
  }
  else
    return NULL;
}


//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeRezervace::ubratPolozku(TRezervace *smazat){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==smazat)
    {
      polozky.ubrat(i);
      pocet--;
      break;
    }
  }
}

//zrusi rezervace na dany titul
/*void TDatabazeRezervace::ubratPolozkyKnih(TKniha *kni){
  for(int w=0;w<pocet;w++)
  {
    if(polozky[w]->dejTitul()==kni)
    {
      polozky.ubrat(w);
      pocet--;
    }
  }
} */


//zrusi rezervace daneho ctenare
/*void TDatabazeRezervace::ubratPolozkyCten(TCtenar *cte){
  for(int o=0;o<pocet;o++)
  {
    if(polozky[o]->dejCtenar()==cte)
    {
      polozky.ubrat(o);
      pocet--;
    }
  }
} */


//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeRezervace::zmenitPolozku(TRezervace *stara, TRezervace *nova){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      polozky.uloz(nova,i);
      delete stara;
      break;
    }
  }
}




//provede ulozeni vsech polozek do souboru
void TDatabazeRezervace::ulozitDoSouboru(){
  long int ic,it;
  file =fopen(soubor,"w");
  if(file==NULL) cout<<"Soubor nelze otevrit.\n";
  else{
    for(int f=0; f<pocet; f++){
      ic=polozky[f]->dejIdc();
      it=polozky[f]->dejIdt();
      fprintf(file,"%ld %ld\n",ic,it);
    }
    fclose(file);
  }
}

//nacte ze souboru polozky
void TDatabazeRezervace::nacistSoubor(){
  TRezervace *uk;
  long int ic,it;
  file=fopen(soubor,"r");
  if(file==NULL) cerr<<"Soubor nelze otevrit.\n";
  else{
   while(!feof(file))
   {
    if(fscanf(file,"%ld %ld",&ic,&it)!=2) break;
    if((uk=new TRezervace(ic,it))==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    pridatPolozku(uk);
   }
  }
}


//konstruktor
TDatabazeRezervace::TDatabazeRezervace(const char *soub){
  soubor=soub;
  aktualni=-1;
  pocet=0;
}



//prida do databaze novou polozku
void TDatabazeRezervace::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;

  polozky.uloz((TRezervace *)jina,pocet-1);
}


