#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <stdlib.h>
#include "konstant.h"
#include "tdatum.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tctenar.h"
#include "tvypujck.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatcten.h"
#include "tdatvypu.h"

#pragma option -Jgx

//vrati vypujcky daneho ctenare
TVypujcka** TDatabazeVypujcka::dejPolozky(TCtenar *ctenar,int *poc)
{
  TVypujcka **vysledek;
  TVypujcka **vysledek2;
  int kolik=0;
  vysledek=NULL;
  for(int q=0;q<pocet;q++)
  {
    if(ctenar==polozky[q]->dejCtenar())
    {
      kolik++;
      vysledek2=new TVypujcka*[kolik];
      for(int k=0;k<kolik-1;k++)
	vysledek2[k]=vysledek[k];
/**/  delete vysledek;
      vysledek=vysledek2;
      vysledek[k]=polozky[q];
    }
  }
  *poc=kolik;
  return vysledek;
}


//podle prirustkoveho cisla kopie najde ukazatele na kopie
void TDatabazeVypujcka::utvorVazbyKop(TDatabazeKopie *kop){
  TKopie *ptr;
  for(int q=0;q<pocet;q++)
  {
    if( (ptr = (kop->dejPolozku(polozky[q]->dejIdk()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenKopie(ptr);
  }
}

//podle id ctenare najde ukazatele na ctenare
void TDatabazeVypujcka::utvorVazbyCten(TDatabazeCtenar *ct){
  TCtenar *ptr;
  for(int q=0;q<pocet;q++)
  {
    if( (ptr = (ct->dejPolozku(polozky[q]->dejIdc()))) == NULL)
      ubratPolozku(polozky[q]);
    else
      polozky[q]->zmenCtenar(ptr);
  }
}

//vrati ukazatel na polozku databaze na aktualni pozici
void* TDatabazeVypujcka::dejDalsi(){
  if(aktualni<pocet-1)
  {
    aktualni+=1;
    return polozky[aktualni];
  }
  else
    return NULL;
}

//vrati ukazatel na polozku databaze na aktualni pozici//vrati ukazatel na polozku databaze pred aktualni pozici
void* TDatabazeVypujcka::dejPredchozi(){
  if(aktualni>0)
  {
    aktualni--;
    return polozky[aktualni];
  }
  else
    return NULL;
}


//ubere danou polozku z pole a nasledne ji smaze
void TDatabazeVypujcka::ubratPolozku(TVypujcka *smazat){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==smazat)
    {
      polozky.ubrat(i);
      pocet--;
      break;
    }
  }
}

//smaze vypujcky na danou kopii
/*void TDatabazeVypujcka::ubratPolozkyKop(TKopie *kp){
  for(int x=0;x<pocet;x++)
  {
    if(polozky[x]->dejKopie()==kp)
    {
      polozky.ubrat(x);
      pocet--;
    }
  }
} */

//smaze vypujcky daneho ctenare
/*void TDatabazeVypujcka::ubratPolozkyCten(TCtenar *ct){
  for(int r=0;r<pocet;r++)
  {
    if(polozky[r]->dejCtenar()==ct)
    {
      polozky.ubrat(r);
      pocet--;
    }
  }
} */


//zmeni obsah jedne polozku podle druhe polozky
void TDatabazeVypujcka::zmenitPolozku(TVypujcka *stara, TVypujcka *nova){
  for(int i=0;i<pocet;i++)
  {
    if(polozky[i]==stara)
    {
      delete stara;
      polozky.uloz(nova,i);
      break;
    }
  }
}


//provede ulozeni vsech polozek do souboru
void TDatabazeVypujcka::ulozitDoSouboru(){
  long int ic,ik;
  int d,m,r;
  file =fopen(soubor,"w");
  if(file==NULL) cout<<"Soubor nelze otevrit.\n";
  else{
   for(int f=0; f<pocet; f++){
    ic=polozky[f]->dejIdc();
    ik=polozky[f]->dejIdk();
    fprintf(file,"%ld %ld ",ic,ik);
    d=(polozky[f]->dejDatumPujceni())->dejDen();
    m=(polozky[f]->dejDatumPujceni())->dejMesic();
    r=(polozky[f]->dejDatumPujceni())->dejRok();
    fprintf(file,"%d %d %d ",d,m,r);
    d=(polozky[f]->dejDatumVraceni())->dejDen();
    m=(polozky[f]->dejDatumVraceni())->dejMesic();
    r=(polozky[f]->dejDatumVraceni())->dejRok();
    fprintf(file,"%d %d %d\n",d,m,r);
   }
  }
  fclose(file);
}


//nacte ze souboru polozky
void TDatabazeVypujcka::nacistSoubor(){
  TVypujcka *uk;
  TDatum *dp,*dv;
  long int ic,ik;
  int d,m,r;
  file=fopen(soubor,"r");
  if(file==NULL) cout<<"Soubor nelze otevrit.\n";
  else{
   while(!feof(file))
   {
    if(fscanf(file,"%ld %ld",&ic,&ik)!=2) break;
    if(fscanf(file,"%d %d %d",&d,&m,&r)!=3) break;
    if((dp=new TDatum(d,m,r))==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    if(fscanf(file,"%d %d %d",&d,&m,&r)!=3) break;
    if((dv=new TDatum(d,m,r))==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    if((uk=new TVypujcka(ic,ik,dp,dv))==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    pridatPolozku(uk);
   }
  }
}



//konstruktor
TDatabazeVypujcka::TDatabazeVypujcka(const char *soub){
  soubor=soub;
  aktualni=-1;
  pocet=0;
}


//prida do databaze novou polozku
void TDatabazeVypujcka::pridatPolozku(TPolozkaDatabaze* jina){
  if(pocet==polozky.Delka())
    polozky.prodluz(PRODLOUZENI);
  pocet++;
  polozky.uloz((TVypujcka *)jina,pocet-1);
}

