#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tdatum.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tctenar.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tvypujck.h"
#include "trezerva.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "tdatcten.h"
#include "tdatvypu.h"
#include "tdatreze.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tsezknih.h"
#include "tsezauto.h"
#include "tsezvypu.h"
#include "tsezreze.h"
#include "tsezcten.h"
#include "tsezkopi.h"
#include "thlmenu.h"

const char* THlavniMenu::text[]={"Seznam knih","Seznam autoru","Seznam kopii",
   "Seznam ctenaru","Seznam rezervaci","Seznam vypujcek"};
const int THlavniMenu::MENU_POLOZEK=6;

//konstruktor
THlavniMenu::THlavniMenu()
{
  if((napsal=new TDatabazeNapsal("napsal.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  if((kopie=new TDatabazeKopie("kopie.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  if((autor=new TDatabazeAutor("autor.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  if((kniha=new TDatabazeKniha("knihy.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  if((ctenar=new TDatabazeCtenar("ctenar.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  if((rezervace=new TDatabazeRezervace("rezervac.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  if((vypujcka=new TDatabazeVypujcka("vypujcka.dat"))==NULL){
    cerr<<"Malo pameti pro beh programu";
    exit(0);
  }
  kniha->nacistSoubor();
  autor->nacistSoubor();
  napsal->nacistSoubor();
  kopie->nacistSoubor();
  ctenar->nacistSoubor();
  rezervace->nacistSoubor();
  vypujcka->nacistSoubor();
  napsal->utvorVazbyTit(kniha);
  napsal->utvorVazbyAut(autor);
  kopie->utvorVazby(kniha);
  rezervace->utvorVazbyTit(kniha);
  rezervace->utvorVazbyCten(ctenar);
  vypujcka->utvorVazbyKop(kopie);
  vypujcka->utvorVazbyCten(ctenar);
  aktualni=0;
  int g=0;
  nap_text[g++]="<F10> - konec programu";
  nap_text[g++]="<SIPKA NAHORU> - pohyb nahoru";
  nap_text[g++]="<SIPKA DOLU> - pohyb dolu";
  nap_text[g++]="<ENTER> - zobrazi vybranou polozku";
  for(;g<RADKU_NAPOVEDY;g++)
    nap_text[g]="";
}

//destruktor
THlavniMenu::~THlavniMenu(){
 delete napsal;
 delete kopie;
 delete autor;
 delete kniha;
 delete ctenar;
 delete rezervace;
 delete vypujcka;
}

//zobrazi menu
void THlavniMenu::zobraz(){
  int y=LHY;
  int velikost=textheight(" ")*2;
  clearviewport();
  setcolor(LIGHTRED);
  outtextxy(LHX,y,"HLAVNI MENU");
    y+=velikost;
  for(int i=0;i<MENU_POLOZEK;i++)
  {
    setcolor(WHITE);
    if(i==aktualni)
    {
      setcolor(RED);
      outtextxy(LHX,y,text[i]);
      setcolor(WHITE);
    }
    else
      outtextxy(LHX,y,text[i]);
    y+=velikost;
  }
}

//ovlada pohyb v menu a vyber
void THlavniMenu::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(1)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DOLU:  if(aktualni<MENU_POLOZEK-1)
		   {
		     aktualni++;
		     zobraz();
		   }
		   break;
	case NAHORU:  if(aktualni>0)
		   {
		     aktualni--;
		     zobraz();
		   }
		   break;
	case F10:exit(0);
		 break;
      }
    }
    else
      if((int)znak==13)
      {
	switch(aktualni){
	  case KNI: TSeznamKniha seznam_kn(kniha,kopie,napsal,autor);
		  seznam_kn.run();
		  seznam_kn.~TSeznamKniha();
                  napoveda();
		  zobraz();
		  break;
	  case AUT: TSeznamAutor seznam_aut(autor,napsal);
		  seznam_aut.run();
		  seznam_aut.~TSeznamAutor();
		  napoveda();
		  zobraz();
		  break;
	  case KOP: TSeznamKopie seznam_kop(kopie,napsal);
		  seznam_kop.run();
		  seznam_kop.~TSeznamKopie();
		  napoveda();
		  zobraz();
		  break;
	  case CTE: TSeznamCtenar seznam_cten(ctenar,vypujcka,rezervace);
		  seznam_cten.run();
		  napoveda();
		  zobraz();
		  break;
	  case REZ: TSeznamRezervace seznam_rez(rezervace,napsal,ctenar,kniha,kopie,autor);
		  seznam_rez.run();
		  napoveda();
		  zobraz();
		  break;
	  case VYP: TSeznamVypujcka seznam_vyp(vypujcka,napsal,ctenar,kopie);
		  seznam_vyp.run();
		  napoveda();
		  zobraz();
		  break;

	}
      }
  }
}
