#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <iostream.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "tautor.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "trozhran.h"
#include "tpodrobn.h"
#include "tpodauto.h"


//zobrazi chybove hlasky
int TPodrobnostiAutor::chyba(int druh)
{
  char znak;
  int y,vyska,navrat;
  clearviewport();
  y=LHY;
  setcolor(WHITE);
  vyska=2*textheight(" ");
  if(druh==NUL_JMENO){
    outtextxy(LHX,y,"Jmeno musi byt nenulove delky.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    zobraz();
    return -1;
  }
  return 0;
}

//nacitani zmen v zaznamu a nacitani novych zaznamu
int TPodrobnostiAutor::zmeny(){
  char *retezec;
  char znak=1;
  char rozsir='\0';
  int prepis=TRUE;       //Zaznmenava, zda jde o prepis (TRUE) nebo pohyb
  int vysl_dotazu;
  int posledni_kl=0;                //Slouzi k zaznamenani posledni stisknute
  TAutor *nova;              //klavesy
  nova=new TAutor(*autor);
  if(nova==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(0);
  }
  inicNapoveda(ZMENA);
  napoveda();
  while(1)
  {
    if(posledni_kl==DOLU || posledni_kl==NAHORU || posledni_kl==F2
       || posledni_kl==F1){
      znak='\0';          //Bylo-li posledni nacitani ukonceno jednou
      prepis=FALSE;   //z danych klaves je pokracovano jeji akci
    }
    else
      if(prepis==FALSE){    //Pokud je nastavena promenna prepis
			    //je primo zvolen rezim zmeny
	while(!kbhit());        //Nacteni z klavesnice
	znak=getch();
      }
    if(prepis==TRUE)          //Urci zda jde o nacitani
    {
      if(aktualni==RAD_JMENO){         //Podle aktualniho radku meni danou
	retezec=new char[RETEZEC];     //polozku zaznamu - nazev
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,RETEZEC);
	nova->zmenJmeno(retezec);
      }
      strcpy(text[aktualni],retezec);    //Nakopiruje posledni nacteny
      if(posledni_kl==1)             //retezec i do zobrazovaneho pole
	posledni_kl=DOLU;
    }
    else{                                //Nejde o nacitani
      if(znak=='\0')
      {
	if(posledni_kl==DOLU ||posledni_kl==NAHORU||posledni_kl==F2
	 ||posledni_kl==F1)
	  rozsir=posledni_kl;           //Priradi konkretni akci podle posledniho
	else                     //nacitani, nebo akci podle klavesnice nyni
	  rozsir=getch();
	if(rozsir==F1){           //Ukonceno bez ukladani
	  delete nova;
	  return FALSE;
	}
	if(rozsir==DOLU)        //Obsluha sipky dolu
	{
	  posledni_kl=0;
	  if(aktualni<STD_POLOZEK-1){
	    aktualni++;       //Pod atualnim radkem je zobrazen jeste jeden
	    zobraz();
	  }
	  if(aktualni<STD_POLOZEK)
	    prepis=TRUE;            //Pokud jde o jednu z polozek zaznamu
			 //knihy (tedy ne autor nebo kopie) bude zvolen
		       //rezim prepisu
	}                           //funkce na posun obrazu
	if(rozsir==NAHORU){          //Obsluha sipky nahoru
	  posledni_kl=0;
	  if(aktualni>pocatek){
	    aktualni--;
	    zobraz();
	  }
	  if(aktualni<STD_POLOZEK)
	    prepis=TRUE;
	}
	if(rozsir==F2){        //Obsluha ukladani
	  posledni_kl=0;
	  if(je_nova==FALSE){       //Jde-li o zmenu stareho zaznamu
	    vysl_dotazu=dotaz();    //zepta se na pokracovani
	    if(vysl_dotazu==FALSE){     //Neukladat - znovu zobrazi puvodni
	      utvorZaznam();
	      zobraz();
	      delete nova;
	      break;
	    }
	    if(vysl_dotazu==POKRACOVAT){      //Pokracovat - dale rezim nacitani
	      prepis=TRUE;
	      continue;
	    }
	    if(vysl_dotazu==TRUE){     //Ulozit - kontrola nenulove delky
				    //nadpisu a zmeneneho ISBN
	      if(strlen(nova->dejJmeno())!=0){
		datautor->zmenitPolozku(autor,nova);
		delete nova;
		return TRUE;   //Provedl zmeny
	      }
	      else{              //Delka nadpisu byla nulova
		prepis=TRUE;  //Zobrazi chybu a nasledne pokracuje v zadavani
		chyba(NUL_JMENO);
		continue;
	      }
	    }
	  }
	  else{              //Jde-li o zadavani noveho zaznamu
	    if(strlen(nova->dejJmeno())==0){  //Kontrola delky nazvu
	      chyba(NUL_JMENO);
	      prepis=TRUE;
	      continue;
	    }
	    else{
	      datautor->pridatPolozku(nova); //Prida polozku do databaze
	      je_nova=FALSE;                 //knih
	      return TRUE;
	    }
	  }
	}
	if(rozsir==F10)    //Ukonceni programu
	  exit(0);
      }
    }
  }
  return FALSE;
}

//ulozi texty na zobrazovani
void TPodrobnostiAutor::utvorZaznam(){
  radku=0;
  int i;
  nadpis[radku]="Jmeno: ";
  strcpy(text[radku],autor->dejJmeno());
  radku++;
  i=0;
  while(i<pocet_titulu)
  {
    if(radku==STD_POLOZEK)
      nadpis[radku]="Napsal: ";
    else
      nadpis[radku]="        ";

    strcpy(text[radku],(napsal[i]->dejTitul())->dejNazev());
    radku++;
    i++;
  }
}

//konstruktor
TPodrobnostiAutor::TPodrobnostiAutor(TAutor *aut,TDatabazeAutor *dataut,TDatabazeNapsal *nap){
  STD_POLOZEK=1;
  aktualni=0;
  pocatek=0;
  datautor=dataut;
  char *jmeno;
  if(aut!=NULL){
    autor=aut;
    je_nova=FALSE;
    napsal=nap->dejPolozky(autor,&pocet_titulu);
  }
  else{
    if((jmeno=new char[RETEZEC])==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    jmeno[0]='\0';
    autor=new TAutor(jmeno,datautor->dejVolneId());
    if(autor==NULL){
      cerr<<"Malo pameti"<<endl;
      exit(0);
    }
    je_nova=TRUE;
    pocet_titulu=0;
  }
  utvorZaznam();
  inicNapoveda();
}

//posune zobrazovanou cast textu
int TPodrobnostiAutor::posun(int kolik){
  int i;
  if(kolik==1)
  {
    if(aktualni<radku-1)
    {
       aktualni++;
       pocatek++;
       zobraz();
       return 1;
    }
    else
      return 0;
  }
  if(kolik==-1)
  {
    if(aktualni>0 && pocatek>0)
    {
      aktualni--;
      pocatek--;
      zobraz();
      return kolik;
    }
    else
      return 0;
  }
  return 0;
}


//ovladani
int TPodrobnostiAutor::run()
{
  char znak,rozsir;
  int zmen=0;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    if(je_nova==FALSE)         //Pokud nejde o zadavani noveho zaznamu
    {                          //je nacitano ovladani z klavesnice
      while(!kbhit());
      znak=getch();
    }
    else
      znak='\0';            //Pro novy zaznam je volena rozsirena klavesa
    if(znak=='\0')
    {
      if(je_nova==FALSE)   //Nejde-li o novy zaznam nacita kod klavesy
	rozsir=getch();     //ze stdin
      else
      {
	rozsir=F4;        //Pro novy zaznam automaticky voli rezim
      }                  //zmen - tedy klavesu F4
      switch(rozsir){
	case DOLU: if(aktualni-pocatek<RADKU-1 && aktualni<radku-1){
		    aktualni++;
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>pocatek){
		   aktualni--;
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F4: if(zmeny()==FALSE)
		   return FALSE;
		 else
		   zmen++;
		 inicNapoveda();
		 napoveda();
		 break;
	case F10:exit(0);
		 break;

      }
    }
    else
      if(znak==ENTER)
	if(zmen>0)
	  return TRUE;
	else
	  return FALSE;
  }
}
