#include <iostream.h>
#include <string.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "tdatum.h"
#include "pol_dat.h"
#include "tctenar.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "trezerva.h"
#include "tvypujck.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatcten.h"
#include "tdatreze.h"
#include "tdatvypu.h"
#include "trozhran.h"
#include "tpodrobn.h"
#include "tpodcten.h"


const int TPodrobnostiCtenar::NAZEV_ZNAKU=40;
const int TPodrobnostiCtenar::ID_ZNAKU=11;


//zobrazi chybove hlasky
int TPodrobnostiCtenar::chyba(int druh)
{
  char znak;
  int y,vyska,navrat;
  clearviewport();
  y=LHY;
  setcolor(WHITE);
  zrusNapoveda();
  vyska=2*textheight(" ");
  if(druh==ZMEN_ID){
    outtextxy(LHX,y,"Bylo zmeneno ID ctenare. Prejete si i presto ulozit.");
    y+=2*vyska;
    outtextxy(LHX,y,"<A> - Ano        <N> - Ne        <P> - Pokracovat");
    while(TRUE){
      while(!kbhit());
      znak=getch();
      if(znak=='A' || znak=='a'){
	navrat=TRUE;
	break;}
      if(znak=='N' || znak=='n'){
	navrat=FALSE;
	break;}
      if(znak=='P' || znak=='p'){
	navrat=POKRACOVAT;
	break;}
    }
    zobraz();
    napoveda();
    return navrat;
  }
  if(druh==NUL_JMENO){
    outtextxy(LHX,y,"Jmeno musi byt nenulove delky.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    zobraz();
    napoveda();
    return -1;
  }
  if(druh==NUL_ID){
    outtextxy(LHX,y,"ID musi byt nenulove delky.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    zobraz();
    napoveda();
    return -1;
  }
  if(druh==EXIST_ID){
    outtextxy(LHX,y,"Zadane ID jiz je prirazeno jinemu ctenari v databazi.");
    y+=2*vyska;
    outtextxy(LHX,y,"Stiskni cokoliv.");
    while(!kbhit());
    getch();
    zobraz();
    napoveda();
    return -1;
  }
  return 0;
}


//nacitani zmen v zaznamu a nacitani novych zaznamu
int TPodrobnostiCtenar::zmeny(){
  char *retezec;
  char znak=1;
  char rozsir='\0';
  int prepis=TRUE;       //Zaznmenava, zda jde o prepis (TRUE) nebo pohyb
  int vysl_dotazu;
  int posledni_kl=0;                //Slouzi k zaznamenani posledni stisknute
  TCtenar *nova;              //klavesy
  TCtenar *stejna;
  nova=new TCtenar(*ctenar);
  if(nova==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(0);
  }
  inicNapoveda(ZMENA);
  napoveda();
  while(1)
  {
    if(posledni_kl==DOLU || posledni_kl==NAHORU || posledni_kl==F2
       || posledni_kl==F1){
      znak='\0';          //Bylo-li posledni nacitani ukonceno jednou
      prepis=FALSE;   //z danych klaves je pokracovano jeji akci
    }
    else
      if(prepis==FALSE){    //Pokud je nastavena promenna prepis
			    //je primo zvolen rezim zmeny
	while(!kbhit());        //Nacteni z klavesnice
	znak=getch();
      }
    if(prepis==TRUE)          //Urci zda jde o nacitani
    {
      if(aktualni==RAD_JMENO){         //Podle aktualniho radku meni danou
	retezec=new char[RETEZEC];     //polozku zaznamu - nazev
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,RETEZEC);
	strcpy(text[aktualni],retezec);    //Nakopiruje posledni nacteny
	nova->zmenJmeno(retezec);
      }
      if(aktualni==RAD_ADRESA){        //Zmena nakladatelstvi
	retezec=new char[RETEZEC];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,RETEZEC);
	strcpy(text[aktualni],retezec);    //Nakopiruje posledni nacteny
	nova->zmenAdresa(retezec);
      }
      if(aktualni==RAD_RC){            //Zmena roku vydani
	retezec=new char[RETEZEC];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,RC_ZNAKU);
	nova->zmenRC(retezec);
	strcpy(text[aktualni],retezec);    //Nakopiruje posledni nacteny
      }
      if(aktualni==RAD_ID){         //Zmena poctu stran
	long int ident;
	retezec=new char[ID_ZNAKU];
	if(retezec==NULL){
	  cerr<<"Malo pameti pro beh programu";
	  exit(0);
	}
	strcpy(retezec,text[aktualni]);
	posledni_kl=zadavani(retezec,ID_ZNAKU);
	if(sscanf(retezec,"%ld",&ident)==0)
	  ident=0L;
	strcpy(text[aktualni],retezec);
	delete retezec;
	nova->zmenId(ident);
      }
      if(posledni_kl==1)             //retezec i do zobrazovaneho pole
	posledni_kl=DOLU;
    }
    else{                                //Nejde o nacitani
      if(znak=='\0')
      {
	if(posledni_kl==DOLU ||posledni_kl==NAHORU||posledni_kl==F2
	 ||posledni_kl==F1)
	  rozsir=posledni_kl;           //Priradi konkretni akci podle posledniho
	else                     //nacitani, nebo akci podle klavesnice nyni
	  rozsir=getch();
	if(rozsir==F1){           //Ukonceno bez ukladani
	  delete nova;
	  return TRUE;
	}
	if(rozsir==DOLU)        //Obsluha sipky dolu
	{
	  posledni_kl=0;
	  if(aktualni<STD_POLOZEK-1){
	    aktualni++;       //Pod atualnim radkem je zobrazen jeste jeden
	    zobraz();
	  }
	  if(aktualni<STD_POLOZEK)
	    prepis=TRUE;            //Pokud jde o jednu z polozek zaznamu
			 //knihy (tedy ne autor nebo kopie) bude zvolen
		       //rezim prepisu
	}                           //funkce na posun obrazu
	if(rozsir==NAHORU){          //Obsluha sipky nahoru
	  posledni_kl=0;
	  if(aktualni>pocatek){
	    aktualni--;
	    zobraz();
	  }
	  if(aktualni<STD_POLOZEK)
	    prepis=TRUE;
	}
	if(rozsir==F2){        //Obsluha ukladani
	  posledni_kl=0;
	  if(je_nova==FALSE){       //Jde-li o zmenu stareho zaznamu
	    vysl_dotazu=dotaz();    //zepta se na pokracovani
	    if(vysl_dotazu==FALSE){     //Neukladat - znovu zobrazi puvodni
	      utvorZaznam();
	      zobraz();
	      delete nova;
	      break;
	    }
	    if(vysl_dotazu==POKRACOVAT){      //Pokracovat - dale rezim nacitani
	      prepis=TRUE;
	      continue;
	    }
	    if(vysl_dotazu==TRUE){     //Ulozit - kontrola nenulove delky
				    //nadpisu a zmeneneho ISBN
	      if(strlen(nova->dejJmeno())!=0){
		if(nova->dejId()==ctenar->dejId()){
		  datctenar->zmenitPolozku(ctenar,nova);
		  delete nova;
		  return TRUE;   //Provedl zmeny
		}
		else vysl_dotazu=chyba(ZMEN_ID);{
					     //Zobrazi chybu zmeneni ISBN
		  if(vysl_dotazu==TRUE){        //Uklada i zmenene ISBN
		    if(datctenar->dejPolozku(nova->dejId())!=NULL){
		      prepis=TRUE;           //Kontrola jednoznacnosti
		      chyba(EXIST_ID);      //ISBN v databazi
		      continue;
		    }
		    else{
		      datctenar->zmenitPolozku(ctenar,nova);
		      delete nova;
		      return TRUE;
		    }
		  }
		  if(vysl_dotazu==FALSE)        //Neuklada, zobrazi puvodni
		  {
		    utvorZaznam();
		    zobraz();
		    delete nova;
		    break;
		  }
		  if(vysl_dotazu==POKRACOVAT){     //Pokracuje ve zmenach
		    prepis=TRUE;
		    continue;
		  }
		}
	      }
	      else{              //Delka nadpisu byla nulova
		prepis=TRUE;  //Zobrazi chybu a nasledne pokracuje v zadavani
		chyba(NUL_JMENO);
		continue;
	      }
	    }
	  }
	  else{              //Jde-li o zadavani noveho zaznamu
	    if(nova->dejId()==0L){   //Kontrola Id
	      chyba(NUL_ID);
	      prepis=TRUE;
	      continue;
	    }
	    else{
	      if(strlen(nova->dejJmeno())==0){  //Kontrola delky nazvu
		chyba(NUL_JMENO);
		prepis=TRUE;
		continue;
	      }
	      else{
		if(datctenar->dejPolozku(nova->dejId())!=NULL){
		  prepis=TRUE;             //Kontrola jednoznacnosti ISBN
		  chyba(EXIST_ID);
		  continue;
		}
		else{
		  datctenar->pridatPolozku(nova); //Prida polozku do databaze
		  je_nova=FALSE;                 //knih
		  return TRUE;
		}
	      }
	    }
	  }
	}
	if(rozsir==F10)    //Ukonceni programu
	  exit(0);
      }
    }
  }
  return FALSE;
}

//ulozi texty na zobrazovani
void TPodrobnostiCtenar::utvorZaznam(){
  radku=0;
  int i,j,k;
  char *nazev;
  nadpis[radku]="Identifikacni cislo: ";
  ltoa(ctenar->dejId(),text[radku],10);
  radku++;
  nadpis[radku]="Jmeno: ";
  strcpy(text[radku],ctenar->dejJmeno());
  radku++;
  nadpis[radku]="Adresa: ";
  if(ctenar->dejAdresa()==NULL)
    text[radku][0]='\0';
  else
    strcpy(text[radku],ctenar->dejAdresa());
  radku++;
  nadpis[radku]="Rodne cislo: ";
  if(ctenar->dejRC()==NULL)
    text[radku][0]='\0';
  else
    strcpy(text[radku],ctenar->dejRC());
  radku++;
  i=0;
  while(i<pocet_vypujcek)
  {
    if(radku==STD_POLOZEK)
      nadpis[radku]="Pujceno: ";
    else
      nadpis[radku]="         ";
    ltoa((vypujcka[i]->dejKopie())->dejPrirC(),text[radku],10);
    for(k=strlen(text[radku]);k<ID_ZNAKU;k++)
      text[radku][k]=' ';
    j=0;
    nazev=((vypujcka[i]->dejKopie())->dejTitul())->dejNazev();
    while(nazev[j]!='\0' && j<NAZEV_ZNAKU-1)
    {
      text[radku][ID_ZNAKU+j]=nazev[j];
      j++;
    }
    text[radku][ID_ZNAKU+j]='\0';
    radku++;
    i++;
  }


  i=0;
  while(i<pocet_rezervaci)
  {
    if(radku==STD_POLOZEK+pocet_vypujcek)
      nadpis[radku]="Rezervovano: ";
    else
      nadpis[radku]="             ";
    strcpy(text[radku],(rezervace[i]->dejTitul())->dejNazev());
    radku++;
    i++;
  }
}

//konstruktor
TPodrobnostiCtenar::TPodrobnostiCtenar(TCtenar *cten,TDatabazeCtenar *datct,TDatabazeVypujcka *vyp, TDatabazeRezervace *rez){
  STD_POLOZEK = 4;
  aktualni=0;
  radku=0;
  pocatek=0;
  datctenar=datct;
  char *jmeno,*adr,*rc;
  if(cten!=NULL){
    ctenar=cten;
    je_nova=FALSE;
    vypujcka=vyp->dejPolozky(ctenar,&pocet_vypujcek);
    rezervace=rez->dejPolozky(ctenar,&pocet_rezervaci);
  }
  else{
    jmeno=new char[RETEZEC];
    if(jmeno==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    jmeno[0]='\0';
    adr=new char[RETEZEC];
    if(adr==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    adr[0]='\0';
    rc=new char[RC_ZNAKU];
    if(rc==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    rc[0]='\0';
    ctenar=new TCtenar(datctenar->dejVolneId(),jmeno,adr,rc);
    if(ctenar==NULL){
      cerr<<"Malo pameti pro beh programu";
      exit(0);
    }
    je_nova=TRUE;
    pocet_vypujcek=0;
    pocet_rezervaci=0;
  }
  utvorZaznam();
  inicNapoveda(JE_ZMENA);
}


//posune zobrazovanou cast textu
int TPodrobnostiCtenar::posun(int kolik){
  int i;
  if(kolik==1)
  {
    if(aktualni<radku-1)
    {
       aktualni++;
       pocatek++;
       zobraz();
       return 1;
    }
    else
      return 0;
  }
  if(kolik==-1)
  {
    if(aktualni>0 && pocatek>0)
    {
      aktualni--;
      pocatek--;
      zobraz();
      return kolik;
    }
    else
      return 0;
  }
  return 0;
}


//ovladani
int TPodrobnostiCtenar::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    if(je_nova==FALSE)         //Pokud nejde o zadavani noveho zaznamu
    {                          //je nacitano ovladani z klavesnice
      while(!kbhit());
      znak=getch();
    }
    else
      znak='\0';            //Pro novy zaznam je volena rozsirena klavesa
    if(znak=='\0')
    {
      if(je_nova==FALSE)   //Nejde-li o novy zaznam nacita kod klavesy
	rozsir=getch();     //ze stdin
      else
      {
	rozsir=F4;        //Pro novy zaznam automaticky voli rezim
      }                  //zmen - tedy klavesu F4
      switch(rozsir){
	case DOLU: if(aktualni-pocatek<RADKU-1 && aktualni<radku-1)
		  {             //Ovladani posunu
		    aktualni++;
		    zobraz();
		  }
		  else
		    posun(1);    //Posun mimo zobrazenou oblast
		  break;
	case NAHORU:if(aktualni>pocatek)
		 {
		   aktualni--;
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F4: if(zmeny()==TRUE)          //Byly-li v zaznamu provedeny
		   return TRUE;             //zmeny vraci TRUE
		 inicNapoveda();
		 napoveda();
		 break;
	case F10:exit(0);
		 break;

      }
    }
    else
      if(znak==ENTER) return FALSE;     //Nebyly-li provadeny zmeny
  }
}
