#include <iostream.h>
#include <stdlib.h>
#include "tpole.h"
#include "konstant.h"
#include "pol_dat.h"
#include "tautor.h"
#include "tctenar.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tnapsal.h"
#include "tdatum.h"
#include "tvypujck.h"
#include "trezerva.h"



template <class T> void TPole<T>::uloz(T *prv, int poz){
  p[poz]=prv;
}

// konstruktor
template <class T> TPole<T>::TPole( int n ) : delka(n)
{ if ( delka < 1 ) delka = 1;
  p = new T*[delka];
  if (p==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(FALSE);
  }
  for( int h = 0; h < delka; h++)
    p[h] = NULL;
}

// Destruktor
template <class T> TPole<T>::~TPole(){
  delete p;
}



// operator pro pristup k jedn. prvkum pole
template <class T> T* TPole<T>::operator[](int l){
  return p[l];
}

// Kopirovaci konstruktor
template <class T> TPole<T>::TPole(TPole <T>&Q){
  delka = Q.delka;
  p = new T*[delka];
  if(p==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(FALSE);
  }
  copy (Q);
}

//Zvetseni rozsahu pole
template <class T> void TPole<T>::prodluz(int kolik){
  delka=delka+kolik;
  T** novy;
  novy=new T*[delka];
  if(novy==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(FALSE);
  }
  for(int g = 0; g < delka; g++)
    novy[g] = p[g];
  delete p;
  p=novy;
}

//Zmenseni rozsahu pole
template <class T> void TPole<T>::zkrat(int kolik){
  delka=delka-kolik;
  T** novy;
  novy=new T*[delka];
  if(novy==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(FALSE);
  }
  for(int q = 0; q < delka; q++)
    novy[q] = p[q];
  delete p;
  p=novy;
}

template <class T> void TPole<T>::ubrat(int index){
  int q;
  delka--;
  T** novy;
  novy=new T*[delka];
  if(novy==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(FALSE);
  }
  for(q = 0; q < index; q++)
    novy[q] = p[q];
  delete p[q];
  for(q=index;q<delka;q++)
    novy[q]=p[q+1];
  delete p;
  p=novy;
}

// pretizeni operatoru prirazeni
template <class T> TPole<T> &TPole<T>::operator =(TPole<T>& Q){
  if ( this == &Q ) return *this;
  delete p;
  delka = Q.delka;
  p = new T*[delka];
  if(p==NULL){
    cerr<<"Nedostatek pameti pro beh programu";
    exit(FALSE);
  }
  copy(Q);
  return *this;
}


//zjisteni aktualni delky pole
template <class T> int TPole<T>::Delka()const{
  return delka;
}


//kopirovani obsahu pole
template <class T> void TPole<T>::copy(const TPole<T> &Q)
{
  int del=(Q.Delka()<delka)?Q.Delka():delka;

  for(int u = 0; u < del; u++)
    // p[i] = Q.p[i];
    uloz(Q.p[u],u);
}

#pragma option -Jgd
typedef TPole <TPolozkaDatabaze> pole_pol_dat;
typedef TPole <TAutor> pole_autor;
typedef TPole <TCtenar> pole_ctenar;
typedef TPole <TTitul> pole_titul;
typedef TPole <TKniha> pole_kniha;
typedef TPole <TKopie> pole_kopie;
typedef TPole <TNapsal> pole_napsal;
typedef TPole <TVypujcka> pole_vypujcka;
typedef TPole <TRezervace> pole_rezervace;


