#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tpodrobn.h"
#include "tpodauto.h"
#include "tsezauto.h"



//inicializuje ukazatele na zobrazovane texty
void TSeznamAutor::utvorZaznam()
{
  int i,j;
  char *jmeno;
  char *isb;

  for(i=0;i<pocet;i++)
  {
    jmeno=((TAutor *)zobrazeno[i])->dejJmeno();
    j=0;
    while(jmeno[j]!='\0' && j<DEL_RADKU-1)
    {
      text[i][j]=jmeno[j];
      j++;
    }
    text[i][j]='\0';
  }
  for(;i<RADKU;i++)
    text[i][0]='\0';
}


//zjisti polozky databaze pro zobrazeni
void TSeznamAutor::obnoveni(){
  int i;
  i=0;
  pocet=0;
  aktualni=0;
  databaze->zmenAktualni(-1L);
  do
  {
    zobrazeno[i]=(TAutor*)(((TDatabazeAutor *)databaze)->dejDalsi());
    i++;
    pocet++;
  }while(zobrazeno[i-1]!=NULL && i<RADKU);
  if(i!=RADKU) pocet--;
  databaze->zmenAktualni(0L);
}

//konstruktor
TSeznamAutor::TSeznamAutor(TDatabaze *dat, TDatabazeNapsal *nap)
{
  databaze=dat;
  napsal=nap;
  nadpis="JMENO AUTORA";
  nadpis2="AUTORI";
  obnoveni();
  utvorZaznam();
  inicNapoveda(JE_NOVA);
}


//posune zobrazovanou cast textu
int TSeznamAutor::posun(int kolik){
  TPolozkaDatabaze* novyrad;
  int i;

  switch(kolik){
    case -1:
       novyrad=(TAutor*)((TDatabazeAutor*)databaze)->dejPredchozi();
       if(novyrad==NULL) return 0;
       for(i=RADKU-1;i>0;i--)
	 zobrazeno[i]=zobrazeno[i-1];
       zobrazeno[0]=novyrad;
       utvorZaznam();
       zobraz();
       return -1;
    case 1:
       novyrad=(TAutor*)((TDatabazeAutor*)databaze)->dejDalsi();
       if(novyrad==NULL) return 0;
       for(i=0;i<RADKU-1;i++)
	 zobrazeno[i]=zobrazeno[i+1];
       zobrazeno[RADKU-1]=novyrad;
       utvorZaznam();
       zobraz();
       return 1;
    }
  return 0;
}

//ovladani
int TSeznamAutor::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(1)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DELETE:
	    if(pocet==0) break;
	    if(dotaz()==TRUE){
	      ((TDatabazeAutor *)databaze)->ubratPolozku((TAutor *)zobrazeno[aktualni]);
	      obnoveni();
	      utvorZaznam();
	      zobraz();
	    }
	    break;
	case F5:
	    TPodrobnostiAutor podrobnosti(NULL,(TDatabazeAutor*)databaze,napsal);
	    if(podrobnosti.run()==TRUE)
	    {
	      obnoveni();
	      utvorZaznam();
	    }
	    podrobnosti.~TPodrobnostiAutor();
	    zobraz();
	    napoveda();
	    break;
	case DOLU: if(aktualni<pocet-1)
		  {
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0)
		 {
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F2:databaze->ulozitDoSouboru();
		break;
	case F1:return 0;
      }
    }
    else
      if(znak==ENTER&&pocet>0)
      {
	TPodrobnostiAutor podrobnosti((TAutor *)zobrazeno[aktualni],(TDatabazeAutor *)databaze,napsal);
	if(podrobnosti.run()==TRUE)
	{
	  obnoveni();
	  utvorZaznam();
	}
	podrobnosti.~TPodrobnostiAutor();
	zobraz();
	napoveda();
      }
  }
}

//funkce slouzici k vybrani konkretniho autor
//pro zaznam titulu
TAutor* TSeznamAutor::vyber()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  int g=0;
  if(pocet==0) return NULL;
  nap_text[g++]="Vyberte jednoho autora a vyber potvrdte <ALT + A>";
  nap_text[g++]="<F10> - konec programu";
  nap_text[g++]="<F5> - novy autor";
  nap_text[g++]="<SIPKA NAHORU> - pohyb nahoru";
  nap_text[g++]="<SIPKA DOLU> - pohyb dolu";
  nap_text[g++]="<ENTER> - zobrazi vybranou polozku";
  for(;g<RADKU_NAPOVEDY;g++)
    nap_text[g]="";
  napoveda();

  while(1)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case F5:
	    TPodrobnostiAutor podrobnosti(NULL,(TDatabazeAutor*)databaze,napsal);
	    if(podrobnosti.run()==TRUE){
	      obnoveni();
	      utvorZaznam();
	    }
	    podrobnosti.~TPodrobnostiAutor();
	    napoveda();
	    zobraz();
	    break;
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case ALT_A:
		  return (TAutor *)zobrazeno[aktualni];
      }
    }
    else
      if(znak==ENTER && pocet>0){
	TPodrobnostiAutor podrobnosti((TAutor *)zobrazeno[aktualni],(TDatabazeAutor *)databaze,napsal);
	if(podrobnosti.run()==TRUE){
	  obnoveni();
	  utvorZaznam();
	}
	podrobnosti.~TPodrobnostiAutor();
	napoveda();
	zobraz();
      }
  }
}
