#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tdatum.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tctenar.h"
#include "tvypujck.h"
#include "trezerva.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatcten.h"
#include "tdatvypu.h"
#include "tdatreze.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tpodrobn.h"
#include "tpodcten.h"
#include "tsezcten.h"

const int TSeznamCtenar::JMENO_ZNAKU=50;

//inicializuje ukazatele na zobrazovane texty
void TSeznamCtenar::utvorZaznam()
{
  int i,j,k;
  char *jmeno,*rc;
  for(i=0;i<pocet;i++)
  {
    ltoa(((TCtenar *)zobrazeno[i])->dejId(),text[i],10);
    for(k=strlen(text[i]);k<ID_ZNAKU;k++)
      text[i][k]=' ';

    jmeno=((TCtenar *)zobrazeno[i])->dejJmeno();
    j=0;
    while(jmeno[j]!='\0' && j<JMENO_ZNAKU-1)
    {
      text[i][ID_ZNAKU+j]=jmeno[j];
      j++;
    }
    for(;j<JMENO_ZNAKU;j++)
      text[i][ID_ZNAKU+j]=' ';

    rc=((TCtenar *)zobrazeno[i])->dejRC();
    if(rc==NULL)
      rc[0]='\0';
    j=0;
    while(rc[j]!='\0' && j<RC_ZNAKU)
    {
      text[i][ID_ZNAKU+JMENO_ZNAKU+j]=rc[j];
      j++;
    }
    text[i][j+ID_ZNAKU+JMENO_ZNAKU]='\0';
  }
  for(;i<RADKU;i++)
    text[i][0]='\0';
}


//zjisti polozky databaze pro zobrazeni
void TSeznamCtenar::obnoveni(){
  int i;
  i=0;
  pocet=0;
  aktualni=0;
  databaze->zmenAktualni(-1L);
  do
  {
    zobrazeno[i]=(TCtenar*)(((TDatabazeCtenar *)databaze)->dejDalsi());
    i++;
    pocet++;
  }while(zobrazeno[i-1]!=NULL && i<RADKU);
  if(i!=RADKU) pocet--;
  databaze->zmenAktualni(0L);
}

//konstruktor
TSeznamCtenar::TSeznamCtenar(TDatabaze *dat,
      TDatabazeVypujcka *vyp,TDatabazeRezervace *rez)
{
  databaze=dat;
  rezervace=rez;
  vypujcka=vyp;
  nadpis="ID        JMENO                                             RC";
  nadpis2="CTENARI";
  obnoveni();
  utvorZaznam();
  inicNapoveda(JE_NOVA);
}

//posune zobrazovanou cast textu
int TSeznamCtenar::posun(int kolik){
  TPolozkaDatabaze* novyrad;
  int i;

  switch(kolik){
    case -1:
       novyrad=(TCtenar*)((TDatabazeCtenar*)databaze)->dejPredchozi();
       if(novyrad==NULL) return 0;
       for(i=RADKU-1;i>0;i--)
	 zobrazeno[i]=zobrazeno[i-1];
       zobrazeno[0]=novyrad;
       utvorZaznam();
       zobraz();
       return -1;
    case 1:
       novyrad=(TCtenar*)((TDatabazeCtenar*)databaze)->dejDalsi();
       if(novyrad==NULL) return 0;
       for(i=0;i<RADKU-1;i++)
	 zobrazeno[i]=zobrazeno[i+1];
       zobrazeno[RADKU-1]=novyrad;
       utvorZaznam();
       zobraz();
       return 1;
    }
  return 0;
}


//ovladani
int TSeznamCtenar::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DELETE:
	    if(pocet==0) break;
	    if(dotaz()==TRUE){
	      ((TDatabazeCtenar *)databaze)->ubratPolozku((TCtenar *)zobrazeno[aktualni]);
	      obnoveni();
	      utvorZaznam();
	      zobraz();
	    }
	    break;
	case F5:
	    TPodrobnostiCtenar podrobnosti(NULL,(TDatabazeCtenar*)databaze,vypujcka,rezervace);
	    if(podrobnosti.run()>0)
	    {
	      obnoveni();
	      utvorZaznam();
	    }
	    podrobnosti.~TPodrobnostiCtenar();
	    zobraz();
	    napoveda();
	    break;
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F2:databaze->ulozitDoSouboru();
		break;
	case F1:return 0;
      }
    }
    else
      if(znak==ENTER && pocet>0)
      {
	TPodrobnostiCtenar podrobnosti((TCtenar *)zobrazeno[aktualni],(TDatabazeCtenar *)databaze,vypujcka,rezervace);
	if(podrobnosti.run()>0)
	{
	  obnoveni();
	  utvorZaznam();
	}
	podrobnosti.~TPodrobnostiCtenar();
	zobraz();
	napoveda();
      }
  }
}
