#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
//#include "tdatreze.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tsezknih.h"
#include "tpodrobn.h"
#include "tpodknih.h"
#include "tsezauto.h"


const int TSeznamKniha::NAZEV_ZNAKU=62;

//inicializuje ukazatele na zobrazovane texty
void TSeznamKniha::utvorZaznam()
{
  int i,j,k;
  char *nazev;
  char *isb;

  for(i=0;i<pocet;i++)
  {
    strncpy(text[i],((TKniha *)zobrazeno[i])->dejIsbn(),ISBN_ZNAKU);
    for(k=strlen(text[i]);k<ISBN_ZNAKU;k++)
      text[i][k]=' ';
    nazev=((TKniha *)zobrazeno[i])->dejNazev();
    j=0;
    while(nazev[j]!='\0' && j<NAZEV_ZNAKU-1)
    {
      text[i][ISBN_ZNAKU+j]=nazev[j];
      j++;
    }
      text[i][ISBN_ZNAKU+j]='\0';
  }
  for(;i<RADKU;i++)
    text[i][0]='\0';
}


//zjisti polozky databaze pro zobrazeni
void TSeznamKniha::obnoveni(){
  int i;
  i=0;
  pocet=0;
  aktualni=0;
  databaze->zmenAktualni(-1L);
  do
  {
    zobrazeno[i]=(TKniha*)(((TDatabazeKniha *)databaze)->dejDalsi());
    i++;
    pocet++;
  }while(zobrazeno[i-1]!=NULL && i<RADKU);
  if(i!=RADKU)
    pocet--;
  databaze->zmenAktualni(0L);
}

//konstruktor
TSeznamKniha::TSeznamKniha(TDatabaze *dat, TDatabazeKopie *kop,
   TDatabazeNapsal *nap,TDatabazeAutor *aut)
{
  databaze=dat;
  kopie=kop;
  napsal=nap;
  autor=aut;
//  rezervace=rez;
  nadpis="ISBN          NAZEV";
  nadpis2="KNIHY";
  obnoveni();
  utvorZaznam();
  inicNapoveda(JE_NOVA);
}


//posune zobrazovanou cast textu
int TSeznamKniha::posun(int kolik){
  TPolozkaDatabaze* novyrad;
  int i;

  switch(kolik){
    case -1:
       novyrad=(TKniha*)((TDatabazeKniha*)databaze)->dejPredchozi();
       if(novyrad==NULL)
	 return 0;
       for(i=RADKU-1;i>0;i--)
	 zobrazeno[i]=zobrazeno[i-1];
       zobrazeno[0]=novyrad;
       utvorZaznam();
       zobraz();
       return -1;
    case 1:
       novyrad=(TKniha*)((TDatabazeKniha*)databaze)->dejDalsi();
       if(novyrad==NULL)
	 return 0;
       for(i=0;i<RADKU-1;i++)
	 zobrazeno[i]=zobrazeno[i+1];
       zobrazeno[RADKU-1]=novyrad;
       utvorZaznam();
       zobraz();
       return 1;
    }
  return 0;
}

//ovladani
int TSeznamKniha::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DELETE:
	    if(pocet==0) break;
	    if(dotaz()==TRUE){
	      ((TDatabazeKniha *)databaze)->ubratPolozku((TKniha *)zobrazeno[aktualni]);
	      obnoveni();
	      utvorZaznam();
	      zobraz();
	    }
	    break;
	case F5:
	    TPodrobnostiKniha podrobnosti(NULL,(TDatabazeKniha*)databaze,kopie,napsal,autor);
	    if(podrobnosti.run()>0)
	    {
	      obnoveni();
	      utvorZaznam();
	    }
	    podrobnosti.~TPodrobnostiKniha();
	    zobraz();
	    napoveda();
	    break;
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F2:databaze->ulozitDoSouboru();
		kopie->ulozitDoSouboru();
		napsal->ulozitDoSouboru();
		autor->ulozitDoSouboru();
		break;
	case F1:return 0;
      }
    }
    else
      if(znak==ENTER&&pocet>0)
      {
	TPodrobnostiKniha podrobnosti((TKniha *)zobrazeno[aktualni],(TDatabazeKniha*)databaze,kopie,napsal,autor);
	if(podrobnosti.run()>0)
	{
	  obnoveni();
	  utvorZaznam();
	}
	podrobnosti.~TPodrobnostiKniha();
	napoveda();
	zobraz();
      }
  }
}

//slouzi k vybrani urciteho titulu pro rezervaci
TKniha* TSeznamKniha::vyber()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  int g=0;
  if(pocet==0)
    return NULL;
  nap_text[g++]="Vyberte jeden titul a vyber potvrdte <ALT + A>";
  nap_text[g++]="<F10> - konec programu";
  nap_text[g++]="<F1> - zpet";
  nap_text[g++]="<SIPKA NAHORU> - pohyb nahoru";
  nap_text[g++]="<SIPKA DOLU> - pohyb dolu";
  nap_text[g++]="<ENTER> - zobrazi vybranou polozku";
  for(;g<RADKU_NAPOVEDY;g++)
    nap_text[g]="";

  napoveda();
  while(TRUE)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F1: return NULL;
	case ALT_A: return (TKniha *)zobrazeno[aktualni];
      }
    }
    else
      if(znak==ENTER&&pocet>0)
      {
	TPodrobnostiKniha podrobnosti((TKniha *)zobrazeno[aktualni],(TDatabazeKniha*)databaze,kopie,napsal,autor);
	if(podrobnosti.run()==TRUE)
	{
	  obnoveni();
	  utvorZaznam();
	}
	podrobnosti.~TPodrobnostiKniha();
	napoveda();
	zobraz();
      }
  }
}
