#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tctenar.h"
#include "tautor.h"
#include "tnapsal.h"
#include "trezerva.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "tdatcten.h"
#include "tdatreze.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tpodrobn.h"
#include "tpodreze.h"
#include "tsezreze.h"

const int TSeznamRezervace::JMENO_ZNAKU=30;
const int TSeznamRezervace::NAZEV_ZNAKU=30;


//inicializuje ukazatele na zobrazovane texty
void TSeznamRezervace::utvorZaznam()
{
  int i,j,k;
  char *jmeno;
  char *nazev;
  for(i=0;i<pocet;i++)
  {
    ltoa((((TRezervace *)zobrazeno[i])->dejCtenar())->dejId(),text[i],10);
    for(k=strlen(text[i]);k<=ID_ZNAKU;k++)
      text[i][k]=' ';

    jmeno=(((TRezervace *)zobrazeno[i])->dejCtenar())->dejJmeno();
    j=0;
    while(jmeno[j]!='\0' && j<JMENO_ZNAKU)
    {
      text[i][ID_ZNAKU+1+j]=jmeno[j];
      j++;
    }
    for(;j<JMENO_ZNAKU;j++)
      text[i][ID_ZNAKU+1+j]=' ';
    j=0;
    nazev=(((TRezervace *)zobrazeno[i])->dejTitul())->dejNazev();
    while(nazev[j]!='\0' && j<NAZEV_ZNAKU-1)
    {
      text[i][ID_ZNAKU+JMENO_ZNAKU+j]=nazev[j];
      j++;
    }
    for(;j<NAZEV_ZNAKU-1;j++)
      text[i][ID_ZNAKU+JMENO_ZNAKU+j]=' ';
  text[i][ID_ZNAKU+JMENO_ZNAKU+j]='\0';
  }
  for(;i<RADKU;i++)                       //doplni prazdne radky
    text[i][0]='\0';
}


//zjisti polozky databaze pro zobrazeni
void TSeznamRezervace::obnoveni(){
  int i;
  i=0;
  pocet=0;
  aktualni=0;
  databaze->zmenAktualni(-1L);
  do
  {
    zobrazeno[i]=(TRezervace*)(((TDatabazeRezervace *)databaze)->dejDalsi());
    i++;
    pocet++;
  }while(zobrazeno[i-1]!=NULL && i<RADKU);
  if(i!=RADKU) pocet--;
  databaze->zmenAktualni(0L);
}

//konstruktor
TSeznamRezervace::TSeznamRezervace(TDatabaze *dat,TDatabazeNapsal *nap,
     TDatabazeCtenar *cten,TDatabazeKniha *knih,TDatabazeKopie *kop,
     TDatabazeAutor *aut)
{
  databaze=dat;
  datnapsal=nap;
  datctenar=cten;
  datkniha=knih;
  datkopie=kop;
  datautor=aut;
  nadpis="ID CTENARE JMENO CTENARE                NAZEV TITULU";
  nadpis2="REZERVACE";
  obnoveni();
  utvorZaznam();
  inicNapoveda(JE_NOVA);
}


//posune zobrazovanou cast textu
int TSeznamRezervace::posun(int kolik){
  TPolozkaDatabaze* novyrad;
  int i;

  switch(kolik){
    case -1:
       novyrad=(TRezervace*)((TDatabazeRezervace*)databaze)->dejPredchozi();
       if(novyrad==NULL)
	 return 0;
       for(i=RADKU-1;i>0;i--)
	 zobrazeno[i]=zobrazeno[i-1];
       zobrazeno[0]=novyrad;
       utvorZaznam();
       zobraz();
       return -1;
    case 1:
       novyrad=(TRezervace*)((TDatabazeRezervace*)databaze)->dejDalsi();
       if(novyrad==NULL)
	 return 0;
       for(i=0;i<RADKU-1;i++)
	 zobrazeno[i]=zobrazeno[i+1];
       zobrazeno[RADKU-1]=novyrad;
       utvorZaznam();
       zobraz();
       return 1;
    }
  return 0;
}

//ovladani
int TSeznamRezervace::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DELETE:
	    if(pocet==0) break;
	    if(dotaz()==TRUE){
	      ((TDatabazeRezervace *)databaze)->ubratPolozku((TRezervace *)zobrazeno[aktualni]);
	      obnoveni();
	      utvorZaznam();
	      zobraz();
	    }
	    break;
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F1:return 0;
	case F2:databaze->ulozitDoSouboru();
		break;
	case F5:
	     TPodrobnostiRezervace podrobnosti(NULL,datnapsal,datctenar,
		datkniha,datkopie,datautor,(TDatabazeRezervace *)databaze);
	     podrobnosti.run();
	     podrobnosti.~TPodrobnostiRezervace();
/**/         obnoveni();
	     utvorZaznam();
	     zobraz();
	     napoveda();
	     break;
      }
    }
    else
      if(znak==ENTER && pocet>0)
      {
	TPodrobnostiRezervace podrobnosti((TRezervace *)zobrazeno[aktualni],
	  datnapsal,datctenar,datkniha,datkopie,datautor,
	  (TDatabazeRezervace *)databaze);
	podrobnosti.run();
	podrobnosti.~TPodrobnostiRezervace();
	zobraz();
	napoveda();
      }
  }
}
