#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "konstant.h"
#include "tdatum.h"
#include "tpole.h"
#include "pol_dat.h"
#include "ttitul.h"
#include "tkniha.h"
#include "tkopie.h"
#include "tctenar.h"
#include "tautor.h"
#include "tnapsal.h"
#include "tvypujck.h"
#include "tdatabaz.h"
#include "tdattitu.h"
#include "tdatknih.h"
#include "tdatkopi.h"
#include "tdatauto.h"
#include "tdatnaps.h"
#include "tdatcten.h"
#include "tdatvypu.h"
#include "trozhran.h"
#include "tsezpolo.h"
#include "tpodrobn.h"
#include "tpodvypu.h"
#include "tsezvypu.h"

const int TSeznamVypujcka::JMENO_ZNAKU=22;
const int TSeznamVypujcka::NAZEV_ZNAKU=22;


//inicializuje ukazatele na zobrazovane texty
void TSeznamVypujcka::utvorZaznam()
{
  int i,j,k;
  char *jmeno;
  char *nazev;
  for(i=0;i<pocet;i++)
  {
    ltoa((((TVypujcka *)zobrazeno[i])->dejCtenar())->dejId(),text[i],10);
    for(k=strlen(text[i]);k<ID_ZNAKU+1;k++)
      text[i][k]=' ';

    jmeno=(((TVypujcka *)zobrazeno[i])->dejCtenar())->dejJmeno();
    j=0;
    while(jmeno[j]!='\0' && j<JMENO_ZNAKU)
    {
      text[i][ID_ZNAKU+1+j]=jmeno[j];
      j++;
    }
    for(;j<JMENO_ZNAKU;j++)
      text[i][ID_ZNAKU+1+j]=' ';

    ltoa((((TVypujcka *)zobrazeno[i])->dejKopie())->dejPrirC(),text[i]+ID_ZNAKU+j,10);
    for(k=strlen(text[i]);k<2*ID_ZNAKU+JMENO_ZNAKU;k++)
      text[i][k]=' ';
    j=0;
    nazev=((((TVypujcka *)zobrazeno[i])->dejKopie())->dejTitul())->dejNazev();
    while(nazev[j]!='\0' && j<NAZEV_ZNAKU-1)
    {
      text[i][2*ID_ZNAKU+JMENO_ZNAKU+j]=nazev[j];
      j++;
    }
    for(;j<NAZEV_ZNAKU+1;j++)
      text[i][2*ID_ZNAKU+JMENO_ZNAKU+j]=' ';
    text[i][2*ID_ZNAKU+JMENO_ZNAKU+j]='\0';
    k=2*ID_ZNAKU+JMENO_ZNAKU+j;
    itoa((((TVypujcka *)zobrazeno[i])->dejDatumPujceni())->dejDen(),text[i]+k,10);
    k=strlen(text[i]);
    text[i][k]='.';
    k++;
    itoa((((TVypujcka *)zobrazeno[i])->dejDatumPujceni())->dejMesic(),text[i]+k,10);
    k=strlen(text[i]);
    text[i][k]='.';
    k++;
    itoa((((TVypujcka *)zobrazeno[i])->dejDatumPujceni())->dejRok(),text[i]+k,10);
    k=strlen(text[i]);
    text[i][k]='\0';
  }
  for(;i<RADKU;i++)                       //doplni prazdne radky
    text[i][0]='\0';
}


//zjisti polozky databaze pro zobrazeni
void TSeznamVypujcka::obnoveni(){
  int i;
  i=0;
  pocet=0;
  aktualni=0;
  databaze->zmenAktualni(-1L);
  do
  {
    zobrazeno[i]=(TVypujcka*)(((TDatabazeVypujcka *)databaze)->dejDalsi());
    i++;
    pocet++;
  }while(zobrazeno[i-1]!=NULL && i<RADKU);
  if(i!=RADKU) pocet--;
  databaze->zmenAktualni(0L);
}

//konstruktor
TSeznamVypujcka::TSeznamVypujcka(TDatabaze *dat,TDatabazeNapsal *nap,
     TDatabazeCtenar *cten,TDatabazeKopie *kop)
{
  databaze=dat;
  napsal=nap;
  ctenar=cten;
  kopie=kop;

  nadpis="ID CTENARE JMENO CTENARE        PRIR. C.  NAZEV TITULU           VRATIT DO";
  nadpis2="VYPUJCKY";
  obnoveni();
  utvorZaznam();
  inicNapoveda(JE_NOVA);
}


//posune zobrazovanou cast textu
int TSeznamVypujcka::posun(int kolik){
  TPolozkaDatabaze* novyrad;
  int i;

  switch(kolik){
    case -1:
       novyrad=(TVypujcka*)((TDatabazeVypujcka*)databaze)->dejPredchozi();
       if(novyrad==NULL)
	 return 0;
       for(i=RADKU-1;i>0;i--)
	 zobrazeno[i]=zobrazeno[i-1];
       zobrazeno[0]=novyrad;
       utvorZaznam();
       zobraz();
       return -1;
    case 1:
       novyrad=(TVypujcka*)((TDatabazeVypujcka*)databaze)->dejDalsi();
       if(novyrad==NULL)
	 return 0;
       for(i=0;i<RADKU-1;i++)
	 zobrazeno[i]=zobrazeno[i+1];
       zobrazeno[RADKU-1]=novyrad;
       utvorZaznam();
       zobraz();
       return 1;
    }
  return 0;
}

//ovladani
int TSeznamVypujcka::run()
{
  char znak,rozsir;
  znak='\0';
  zobraz();
  napoveda();
  while(TRUE)
  {
    while(!kbhit());
    znak=getch();
    if(znak=='\0')
    {
      rozsir=getch();

      switch(rozsir){
	case DELETE:
	    if(dotaz()==TRUE){
	      ((TDatabazeVypujcka *)databaze)->ubratPolozku((TVypujcka *)zobrazeno[aktualni]);
	      obnoveni();
	      utvorZaznam();
	      zobraz();
	    }
	    break;
	case DOLU: if(aktualni<pocet-1){
		    aktualni++;
		    databaze->posunAktualni(1L);
		    zobraz();
		  }
		  else
		    posun(1);
		  break;
	case NAHORU:if(aktualni>0){
		   aktualni--;
		   databaze->posunAktualni(-1L);
		   zobraz();
		 }
		 else
		   posun(-1);
		 break;
	case F10:exit(0);
		 break;
	case F1:return 0;
	case F2:databaze->ulozitDoSouboru();
		break;
	case F5:
	  TPodrobnostiVypujcka podrobnosti(NULL,napsal,ctenar,kopie,
		(TDatabazeVypujcka *)databaze);
	  if(podrobnosti.run()==TRUE){
	    obnoveni();
	    utvorZaznam();
	  }
	  podrobnosti.~TPodrobnostiVypujcka();
	  zobraz();
	  napoveda();
      }
    }
    else
      if(znak==ENTER && pocet>0)
      {
	TPodrobnostiVypujcka podrobnosti((TVypujcka *)zobrazeno[aktualni],
	    napsal,ctenar,kopie,(TDatabazeVypujcka *)databaze);
	podrobnosti.run();
	podrobnosti.~TPodrobnostiVypujcka();
	zobraz();
      }
  }
}
